﻿using SlnMesnac.RfidUpload.Common;
using SlnMesnac.RfidUpload.Model.config;
using System;
using System.Collections.Generic;
using System.Text;

#region << 版 本 注 释 >>
/*--------------------------------------------------------------------
* 版权所有 (c) 2024 WenJY 保留所有权利。
* CLR版本：4.0.30319.42000
* 机器名称：T14-GEN3-7895
* 命名空间：SlnMesnac.RfidUpload.Model.apiParam
* 唯一标识：82cc9323-4b7f-4490-8b0a-6cd7d56f5f84
*
* 创建者：WenJY
* 电子邮箱：
* 创建时间：2024-10-29 14:53:32
* 版本：V1.0.0
* 描述：
*
*--------------------------------------------------------------------
* 修改人：
* 时间：
* 修改说明：
*
* 版本：V1.0.0
*--------------------------------------------------------------------*/
#endregion << 版 本 注 释 >>
namespace SlnMesnac.RfidUpload.Model.apiParam
{
    /// <summary>
    /// 容器指定封发扫描接口参数
    /// </summary>
    public class ContainerRegisterQuery
    {
        private static readonly Lazy<ContainerRegisterQuery> lazy = new Lazy<ContainerRegisterQuery>(() => new ContainerRegisterQuery());

        public static ContainerRegisterQuery Instance
        {
            get
            {
                return lazy.Value;
            }
        }

        private ContainerRegisterQuery()
        {

        }

        private static INIFile iNIFile = new INIFile(System.Environment.CurrentDirectory + "/App.InI");

        /// <summary>
        /// 机构代码
        /// </summary>
        public string opOrgCode
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "opOrgCode"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "opOrgCode", value.ToString()); }
        }

        /// <summary>
        /// 省份代码
        /// </summary>
        public string opOrgName
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "opOrgName"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "opOrgName", value.ToString()); }
        }

        /// <summary>
        /// 登录人代码
        /// </summary>
        public string userCode
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "userCode"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "userCode", value.ToString()); }
        }

        /// <summary>
        /// 登录人名称
        /// </summary>
        public string userName
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "userName"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "userName", value.ToString()); }
        }

        /// <summary>
        /// 省份代码
        /// </summary>
        public string provice
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "provice"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "provice", value.ToString()); }
        }

        /// <summary>
        /// 容器种类名称
        /// </summary>
        public string rqzlmc
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "rqzlmc"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "rqzlmc", value.ToString()); }
        }

        /// <summary>
        /// 总包id
        /// </summary>
        public string zbid
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "zbid"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "zbid", value.ToString()); }
        }

        /// <summary>
        /// 寄达局名称
        /// </summary>
        public string destinationOrgName
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "destinationOrgName"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "destinationOrgName", value.ToString()); }
        }

        /// <summary>
        /// 寄达局编号
        /// </summary>
        public string destinationOrgCode
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "destinationOrgCode"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "destinationOrgCode", value.ToString()); }
        }

        /// <summary>
        /// 容器种类
        /// </summary>
        public string rqzl
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "rqzl"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "rqzl", value.ToString()); }
        }

        /// <summary>
        /// 容器型号
        /// </summary>
        public string rqxh
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "rqxh"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "rqxh", value.ToString()); }
        }

        /// <summary>
        /// 容器型号名称
        /// </summary>
        public string rqxhmc
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "rqxhmc"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "rqxhmc", value.ToString()); }
        }

        /// <summary>
        /// 容器条码
        /// </summary>
        public string rqtm
        {
            get { return iNIFile.IniReadValue("ContainerRegisterQuery", "rqtm"); }
            set { iNIFile.IniWriteValue("ContainerRegisterQuery", "rqtm", value.ToString()); }
        }
    }
}
