﻿using SlnMesnac.RfidUpload.Common;
using SlnMesnac.RfidUpload.Model.apiParam;
using System;
using System.Collections.Generic;
using System.Text;

#region << 版 本 注 释 >>
/*--------------------------------------------------------------------
* 版权所有 (c) 2024 WenJY 保留所有权利。
* CLR版本：4.0.30319.42000
* 机器名称：T14-GEN3-7895
* 命名空间：SlnMesnac.RfidUpload.Model.config
* 唯一标识：8dc07598-dc8a-4ae3-9f67-bc77314a266e
*
* 创建者：WenJY
* 电子邮箱：
* 创建时间：2024-05-28 14:09:03
* 版本：V1.0.0
* 描述：
*
*--------------------------------------------------------------------
* 修改人：
* 时间：
* 修改说明：
*
* 版本：V1.0.0
*--------------------------------------------------------------------*/
#endregion << 版 本 注 释 >>
namespace SlnMesnac.RfidUpload.Model.config
{
    public class AppConfig
    { 
        private static readonly Lazy<AppConfig> lazy = new Lazy<AppConfig>(() => new AppConfig());


        //private static StringChange stringChange = StringChange.Instance;


        public static AppConfig Instance
        {
            get
            {
                return lazy.Value;
            }
        }

        private AppConfig()
        {
            
        }

        private static INIFile iNIFile = new INIFile(System.Environment.CurrentDirectory + "/App.InI");

        /// <summary>
        /// 过滤间隔
        /// </summary>
        public string filterInterval
        {
            get { return iNIFile.IniReadValue("SystemConfig", "FilterInterval"); }
            set { iNIFile.IniWriteValue("SystemConfig", "FilterInterval", value.ToString()); }
        }

        /// <summary>
        /// 工作模式
        /// </summary>
        public string workModel
        {
            get { return iNIFile.IniReadValue("SystemConfig", "WorkModel"); }
            set { iNIFile.IniWriteValue("SystemConfig", "WorkModel", value.ToString()); }
        }

        /// <summary>
        /// 设备编码
        /// </summary>
        public string requestURL
        {
            get { return iNIFile.IniReadValue("SystemConfig", "RequestURL"); }
            set { iNIFile.IniWriteValue("SystemConfig", "RequestURL", value.ToString()); }
        }

        public string sysCode
        {
            get { return iNIFile.IniReadValue("SystemConfig", "sysCode"); }
            set { iNIFile.IniWriteValue("SystemConfig", "sysCode", value.ToString()); }
        }

        public string password
        {
            get { return iNIFile.IniReadValue("SystemConfig", "password"); }
            set { iNIFile.IniWriteValue("SystemConfig", "password", value.ToString()); }
        }

        public string ak
        {
            get { return iNIFile.IniReadValue("SystemConfig", "ak"); }
            set { iNIFile.IniWriteValue("SystemConfig", "ak", value.ToString()); }
        }

        public string sk
        {
            get { return iNIFile.IniReadValue("SystemConfig", "sk"); }
            set { iNIFile.IniWriteValue("SystemConfig", "sk", value.ToString()); }
        }

        public string opOrgCode
        {
            get { return iNIFile.IniReadValue("SystemConfig", "opOrgCode"); }
            set { iNIFile.IniWriteValue("SystemConfig", "opOrgCode", value.ToString()); }
        }

        public string devicedId
        {
            get { return iNIFile.IniReadValue("SystemConfig", "devicedId"); }
            set { iNIFile.IniWriteValue("SystemConfig", "devicedId", value.ToString()); }
        }


        public string localUrl
        {
            get { return iNIFile.IniReadValue("SystemConfig", "localUrl"); }
            set { iNIFile.IniWriteValue("SystemConfig", "localUrl", value.ToString()); }
        }

        public string RFIDAddress
        {
            get { return iNIFile.IniReadValue("SystemConfig", "RFIDAddress"); }
            set { iNIFile.IniWriteValue("SystemConfig", "RFIDAddress", value.ToString()); }
        }
    }
}
